import { IFormFieldFull, IFormGroupFull } from './inputsModels';
import {
  ICrossFieldConditionsParams,
  ICrossFieldValidationRule,
  IFormFieldBase,
  IFormGroupBase,
  IFormSettingsOverrides,
  IJsonSchema,
  IRegularBreakpoints,
} from './modelsCommon';

export interface IFormSetting {
  overrides?: IFormSettingsOverrides;
  crossFieldValidations?: ICrossFieldValidationRule[];
  crossFieldConditions?: ICrossFieldConditionsParams;
  fieldLayout: IRegularBreakpoints;
}

// Interface for form field
export type IFormSettings = {
  [key in string]: IFormSetting;
};

// Main interface that describes the json form object
export interface IFormParsed {
  formatVersion: 'parsed';
  jsonSchema: IJsonSchema;
  formSettings: IFormSettings;
  children: Array<IFormFieldBase | IFormGroupBase>;
  submitButtonText: string;
  cancelButtonText?: string;
}

export interface IFormParsedFull extends IFormParsed {
  children: Array<IFormFieldFull | IFormGroupFull>;
}
